// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import gc.WeakReference;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

import salsa.resources.SystemService;

import salsa.resources.ActorService;

// End SALSA compiler generated import delcarations.

import java.net.*;
import java.io.*;
import java.util.*;

public class Outside extends UniversalActor  implements ActorService {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		Outside instance = (Outside)new Outside(uan, ual,null).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new Outside(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return Outside.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new Outside(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return Outside.getReferenceByLocation(new UAL(ual)); }
	public Outside(boolean o, UAN __uan)	{ super(false,__uan); }
	public Outside(boolean o, UAL __ual)	{ super(false,__ual); }

	public Outside(UAN __uan,UniversalActor.State sourceActor)	{ this(__uan, null,null); }
	public Outside(UAL __ual,UniversalActor.State sourceActor)	{ this(null, __ual,null); }
	public Outside(UniversalActor.State sourceActor)		{ this(null, null,null);  }
	public Outside()		{  }
	public Outside(UAN __uan, UAL __ual,Object sourceActor) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "Outside");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct (String type, String state, deptup dep) {
		Object[] __arguments = { type, state, dep };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor .State implements salsa.resources.ActorServiceState {
		public Outside self;
		public void updateSelf(ActorReference actorReference) {
			((Outside)actorReference).setUAL(getUAL());
			((Outside)actorReference).setUAN(getUAN());
			self = new Outside(false,getUAL());
			self.setUAN(getUAN());
			self.setUAL(getUAL());
			self.muteGC();
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "Outside$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				if (!message.getMethodName().equals("die")) {message.activateArgsGC(this);}
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		int rollback = OutsideBox.CRASH;
		OutsideBox single;
		String mybehavior;
		int count = 0;
		BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
		public void act(String[] args) {
			mybehavior = "java BoxProgram";
			single = new OutsideBox(this);
			System.out.print("\nUser: ");
			int result;
			String input;
			try {
				input = stdIn.readLine();
				result = single.run(input, new deptup(), rollback);
				rollback = OutsideBox.READY;
				if (input=="Done") {{
					return;
				}
}			}
			catch (Exception e) {
				System.err.println("Error: Standard Input failed");
				return;
			}

			if (result==OutsideBox.CRASH) {{
				rollback = result;
				System.out.println("The program crashed or otherwise exited without sending ready, rollback, or checkpoint.\n");
			}
}			else {if (result==OutsideBox.ROLLBACK) {{
				rollback = result;
				System.out.println("The program rolledback.\n");
			}
}}			System.out.println("====================================================");
			if (single.dep.h.get(getUAN().toString()).isEphemeral()&&!single.dep.h.get(getUAN().toString()).isStable()&&result!=OutsideBox.READY) {{
				System.out.println("Ephemeral.  Quitting");
				return;
			}
}			single.backup();
			{
				// act(args)
				{
					Object _arguments[] = { args };
					Message message = new Message( self, self, "act", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void rcvMessage(String mymessage, deptup d) {
			single = new OutsideBox(this);
			int result = single.run(mymessage, d, OutsideBox.READY);
			if (result==OutsideBox.CRASH) {{
				System.out.println("The program crashed or otherwise exited without sending ready, rollback, or checkpoint.\n");
			}
}			else {if (result==OutsideBox.ROLLBACK) {{
				System.out.println("The program rolledback.\n");
			}
}}			System.out.println("====================================================");
			if (single.dep.h.get(getUAN().toString()).isEphemeral()&&!single.dep.h.get(getUAN().toString()).isStable()) {{
				System.out.println("Ephemeral.  Quitting");
				return;
			}
}		}
		public void sndMessage(String mymessage, String recipient, deptup d) {
			try {
				Outside remoteSVC = (Outside)Outside.getReferenceByName(recipient);
				{
					// remoteSVC<-rcvMessage(mymessage, d)
					{
						Object _arguments[] = { mymessage, d };
						Message message = new Message( self, remoteSVC, "rcvMessage", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
			catch (Exception e) {
				e.printStackTrace();
			}

		}
		public String makeNew(String type, String state, deptup d) {
			String appendo = "/"+String.valueOf(++count);
			String newUan = getUAN().toString()+appendo;
			String newUal = getUAL().toString()+appendo;
			Outside actor = ((Outside)new Outside(new UAN(newUan), new UAL(newUal),this).construct(type, state, d));
			return newUan;
		}
		public String getmyself() {
			return getUAN().toString();
		}
		void construct(String type, String state, deptup dep){
			mybehavior = type;
			single = new OutsideBox(this);
			single.state = state;
			single.dep = dep;
			single.dep.h.put(getUAN().toString(), new history());
		}
		public String getmyBehavior() {
			return mybehavior;
		}
	}
}