import java.net.*;
import java.io.*;
import java.util.*;
import java.beans.*;

public class OutsideBox {	
	public OutsideBox(Outside.State p) {
		parent = p;
	}
	public final Outside.State parent;
	public static final int READY = 0;
	public static final int ROLLBACK = 1;
	public static final int CRASH = 2;
	public static final String FILESAVE = "BoxState.ts";
  protected BufferedReader innerBR;
    protected BufferedReader stdIn;
	protected PrintWriter innerOut;
	protected Process proc;
	protected String state;
	protected deptup dep;
  boolean ephemeral = true;
	
		private boolean testinvalidate(deptup left, deptup right) {
			HashMap<String,history> behavior = new HashMap<String, history>();
			Iterator<String> b = left.b.iterator();
			while (b.hasNext()) {
				String foo = b.next();	
				behavior.put(foo,left.h.get(foo));
				if (behavior.get(foo).isInvalidatedBy(right.h.get(foo))) {
					return true;
				}
			}
			int res;
			do {
				res=behavior.size();
				Set current=behavior.keySet();
				Iterator<String> ite = current.iterator();
				while (ite.hasNext()) {
					String cho=ite.next();
					HashSet<String> l=left.d.get(cho);
					HashSet<String> r=right.d.get(cho);
					if (l != null && left.h.get(cho).almostequals(behavior.get(cho))) {
						Iterator<String> l1 = l.iterator();
						while (l1.hasNext()) {
							String l2 = l1.next();
							behavior.put(l2, left.h.get(l2));
							if (behavior.get(l2).isInvalidatedBy(right.h.get(l2))) {
								return true;
							}
						}
					}
					if (r != null && right.h.get(cho).almostequals(behavior.get(cho))) {
						Iterator<String> r1 = r.iterator();
						while (r1.hasNext()) {
							String r2 = r1.next();
							behavior.put(r2, right.h.get(r2));
						}						
					}
				}
			} while (res!=behavior.size());
			return false;
		}
		
		private boolean independent() {
			ArrayList<String> tester = new ArrayList<String>();
			tester.add(getSelf());
			for(int i=0; i < tester.size(); ++i) {
				String cur = tester.get(i);
				if (!dep.h.get(cur).isStable()) {
					return false;
				}
				HashSet<String> tmp = dep.d.get(cur);
				if (tmp != null) {
					Iterator<String> ite = tmp.iterator();
					while(ite.hasNext()) {
						String nex=ite.next();
						if (!tester.contains(nex)) {
							tester.add(nex);
						}
					}
				}
			}
			return true;
		}
  protected void backup() {
	    try {
						XMLEncoder xd = new XMLEncoder(
																						new BufferedOutputStream(
																					 new FileOutputStream(FILESAVE)));
						backup b = new backup();
						b.deps=dep;
						b.state=state;
						xd.writeObject(b);
						xd.close();
      } catch (IOException E) {
        System.out.println(E);
     }
  }


		private String getSelf() {
			return parent.getUAN().toString();
		}
	private void ready() {
		try {
			proc = Runtime.getRuntime().exec(parent.getmyBehavior());
			innerOut = new PrintWriter(proc.getOutputStream(), true);       
			innerBR = new BufferedReader(new InputStreamReader(proc.getInputStream()));
			stdIn = new BufferedReader(new InputStreamReader(System.in));
		} catch (Exception e) {		
		}
	}
	
    public int run(String message, deptup d, int rolledback) {
					dep = new deptup();
					dep.h.put(getSelf(), new history());
					ready();
		try {
			XMLDecoder xd = new XMLDecoder(
																			new BufferedInputStream(
																			new FileInputStream(FILESAVE)));
			
			backup b = (backup) xd.readObject();			
			xd.close();
			state=b.state;
			dep=b.deps;
			dep.b=new HashSet<String>();
			dep.b.add(getSelf());
			if (testinvalidate(dep,d)) {
				System.out.println("Message caused rollback.");
				dep.b.remove(getSelf());
				return ROLLBACK;
			}
			dep.b.remove(getSelf());
			if (testinvalidate(d,dep)) {
				System.out.println("Message caused was out of date and ignored.");
				return READY;
			}
							
			if (rolledback == ROLLBACK || 
						 (rolledback == CRASH && !dep.h.get(getSelf()).isStable())) {
				history back=dep.h.get(getSelf());
				back.rollback();
				dep = new deptup();
				dep.h.put(getSelf(),back);
			}
		} catch (IOException e) {
		}
		try {
			String inputLine;
			System.out.println("\nMsg: " + message);
			innerOut.println(message);
			while ((inputLine = innerBR.readLine()) != null) {
				System.out.println("Client: " + inputLine);
//Stabilize
				if (inputLine.equals("Stabilize")) {
					System.out.println("Server: Received Stabilize, stabilizing");
					dep.h.get(getSelf()).stabilize();
					backup();
//Getstate
				} else if (inputLine.equals("Getstate")) {
					System.out.println("Server: Received Getstate, sending state: \"" + state + "\"");
					dep.b.add(getSelf());
					innerOut.println(state);
//Setstate
				} else if (inputLine.length() > 9 && inputLine.substring(0,9).equals("Setstate ")) {
					if (!dep.h.get(getSelf()).isStable()) {
						System.out.println("Server: Am volatile, State set to \""+ inputLine.substring(9) + "\".");
						state = inputLine.substring(9);			
						Iterator<String> newstuff = dep.b.iterator();
						if (dep.d.get(getSelf())==null) {
							dep.d.put(getSelf(),new HashSet<String>());
						}
						while(newstuff.hasNext()) {
							dep.d.get(getSelf()).add(newstuff.next());
						}
					} else {
						System.out.println("Server: Am stable, unable to set State to \""+ inputLine.substring(9) + "\".");
					}
//SendTo
				} else if (inputLine.length() > 7 && inputLine.substring(0,7).equals("SendTo ")) {
					String more=inputLine.substring(7);
					int i;
					for (i = 0; i != more.length(); ++i) {
						if (more.substring(i,i+1).equals(" ")) {
							break;
						}
					}
					System.out.println("Server: Told to send \"" + more.substring(i+1) + "\" to \"" + 
										more.substring(0,i));
					parent.sndMessage(more.substring(i+1), more.substring(0,i), dep);
//Rollback
				} else if (inputLine.equals("Rollback")) {
					if (!dep.h.get(getSelf()).isStable()) {
						System.out.println("Server: Received Rollback, rolling back.");
						return ROLLBACK;
					} else {
						System.out.println("Server: Received Rollback but not volatile.");
						return READY;						
					}
//Checkpoint
				} else if (inputLine.equals("Checkpoint")) {
					if (independent()) {
						System.out.println("Server: Received Checkpoint, am independent, checkpointing");
						history tmp = dep.h.get(getSelf());
						dep = new deptup();
						tmp.checkpoint();
						dep.h.put(getSelf(),tmp);
						backup();
						innerOut.println("Bye.");
						return READY;
					} else {
						System.out.println("Server: Received Checkpoint but am not independent.");		
					}				
//Dependent
				} else if (inputLine.equals("Dependent?")) {
					if (independent()) {
						System.out.println("Server: Received Dependent?, false.");
						innerOut.println(false);
					} else {
						System.out.println("Server: Received Dependent?, true.");
						innerOut.println(true);						
					}
						
//Self
				} else if (inputLine.equals("Self")) {
					System.out.println("Server: Received Self");
					innerOut.println(parent.getmyself());
//Ready
				} else if (inputLine.equals("Ready")) {
					System.out.println("Server: Received Ready.  Creating new instance of program");			
					innerOut.println("Bye.");
					return READY;
//New
				} else if (inputLine.length() > 4 && inputLine.substring(0,4).equals("New ")) {
					String type = inputLine.substring(4);
					String state = innerBR.readLine();
					innerOut.println(parent.makeNew(type,state,dep));
				} else if (inputLine.length() > 5 && inputLine.substring(0,5).equals("Echo ")) {
					System.out.println("Server: Echo " + inputLine.substring(5));
				} else {
					System.out.println("Server: Unsupported message:" + inputLine);
				}
			}
		} catch (Exception e) {
			System.out.println("2");
		}
		return CRASH;
	}
}
