import java.net.*;
import java.io.*;
import java.util.*;

public class history implements Serializable {
	private boolean stable;
	private AbstractList<Integer> L;
	private int K;
	public boolean isStable() {
		return stable;
	}
	public boolean isEphemeral() {
		return L.isEmpty();
	}
	public history() {
		stable = false;
		L = new LinkedList<Integer>();
		K = 0;
	}
	public void rollback() {
		K++;
		stable = false;
	}
	public void stabilize() {
		stable = true;
	}
	public void checkpoint() {
		L.add(0,K);
		K = 0;
		stable = false;
	}
	public String toString() {
		String ret = "< ";
		if (stable)
			ret += "s";
		else
			ret += "v";
		ret += "(" + Integer.toString(K) + "), ";
		if (L.isEmpty()) {
			return ret + "nil >";
		}
		ret += L.get(0).toString() + " ";
		for(int i = 1; i != L.size(); ++i)
			ret += ". " + L.get(i).toString() + " ";
		return ret + ">";
	}
 public String toSimpleString() {
   String ret = "";
   if (stable)
     ret += "0";
   else
     ret += "1";
   ret += ","+K;
   for (int i = 0; i != L.size(); ++i)
     ret += "," + L.get(i).toString();
   return ret;
 }
 
 public history(String SimpleString) {
		setHist(SimpleString);
	}
 public void setHist(String hist) {
  String[] tokenized = hist.split(",");
   if (tokenized[0].equals(0))
	   stable = true;
			else
	   stable = false;
   K = Integer.parseInt(tokenized[1]);
   L = new LinkedList<Integer>();
   for (int x=2; x<tokenized.length; ++x)
	   L.add(Integer.parseInt(tokenized[x]));			
 }
	public boolean isSucceededByStar(history right) {
		if (right.L.size() > L.size()) return true;
		if (right.L.size() < L.size()) return false;
		if (right.K > K) return true;
		if (right.K < K) return false;
		if (right.stable == true && stable == false) return true;
		return false;
	}
	
	public boolean isInvalidatedBy(history right) {
		if (right == null) return false;
		history tmp = new history(toSimpleString());
		tmp.rollback();
		return (tmp.isSucceededByStar(right) || tmp.equals(right));
	}
	
	public boolean isOutdatedBy(history right) {
		if (right == null) return false;
		history tmp = new history(toSimpleString());
		tmp.checkpoint();
		return (tmp.isSucceededByStar(right) || tmp.equals(right));
	}
	
	public boolean almostequals(history obj) {
		if (obj == null) return false;
		return (obj.K == K && L.equals(obj.L));
	}
	public boolean equals(Object obj) {
		if (!(obj instanceof history)) return false;
		history foo = (history) obj;
		return (foo.K == K && L.equals(foo.L) && foo.stable == stable);
	}
	
	public String getHist() {
		return toSimpleString();
	}
	
 public void println() {
  System.out.println("History is " + toString());
 }
}

